import "./assets/LoadableIcon.css";
import { jsx as A } from "react/jsx-runtime";
import { useState as k, useEffect as u } from "react";
import C from "./utils/domHelper.js";
import Q from "./utils/network.js";
const I = new DOMParser(), b = {}, H = {}, R = I.parseFromString(
  '<svg stroke="currentColor" fill="currentColor" stroke-width="0" viewBox="0 0 24 24" height="1em" width="1em" xmlns="http://www.w3.org/2000/svg"><rect width="20" height="20" x="2" y="2" fill="none" stroke="#000" stroke-width="2"rx="2"></rect></svg>',
  "image/svg+xml"
).querySelector("svg"), ee = (q) => {
  const {
    classes: t,
    color: r,
    fillColor: m,
    height: E,
    hoverColor: M,
    hoverShadow: L,
    isLocal: w,
    onClick: _,
    onMouseEnter: N,
    onMouseLeave: O,
    size: s,
    skipPathColorFill: v,
    strokeColor: h,
    strokeWidth: d,
    svgString: n,
    style: z,
    svgB64String: l,
    toggleColor: P,
    toggled: S,
    width: W
  } = q;
  let { icon: e } = q;
  const [B, a] = k(), [T, D] = k(), [f, j] = k(), [F, G] = k(
    R
  ), y = e && (e.startsWith("http://") || e.startsWith("https://") || e.startsWith("/"));
  e = e && !y && e.indexOf("/") > -1 ? e.replace(/\//g, ".") : e, e = !n && !l && (!e || !y && e.indexOf(".") < 0) ? "gr.GrStatusPlaceholder" : e;
  const p = e == null ? void 0 : e.split("."), x = p && p[0] ? p[0].toLowerCase() : "", $ = p && p[1], c = e && (x && $ ? `${x}_${$}` : e), g = c && H[c], J = () => {
    e && c && !b[c] && (b[c] = !0, Q.getStatic(
      y ? e : `/icon/${x}/${$}`
    ).then((o) => {
      const i = I.parseFromString(o.body, "image/svg+xml").querySelector("svg");
      i && (H[c] = o.body, G(i));
    }).catch((o) => {
      console.log(o), b[c] = !1;
    }).finally(() => b[c] = !1));
  };
  if (u(() => {
    S !== void 0 && f !== S && j(S);
  }, [S]), u(() => {
    !w && !l && !n && (y && e || $ && x ? !g && J() : console.log("Icon name and category is required, received: ", e));
  }, [e]), u(() => {
    F && !w && a(
      C.svgToBase64(
        F,
        { size: s, classes: t, color: r, fillColor: m, strokeColor: h, strokeWidth: d },
        [!!v]
      )
    );
  }, [F]), u(() => {
    n ? a(btoa(n)) : l && a(l);
  }, [n, l]), u(() => {
    if (!w) {
      const o = T ? M || r : f && P || r;
      if (g || l || n) {
        if (g)
          a(
            C.svgToBase64(
              g,
              {
                size: s,
                classes: t,
                color: o,
                fillColor: m,
                strokeColor: h,
                strokeWidth: d
              },
              [!!v]
            )
          );
        else if (n) {
          const i = I.parseFromString(n, "image/svg+xml").querySelector("svg");
          i && a(
            C.svgToBase64(
              i,
              {
                size: s,
                classes: t,
                color: o,
                fillColor: m,
                strokeColor: h,
                strokeWidth: d
              },
              [!!v]
            )
          );
        } else if (l) {
          const i = I.parseFromString(atob(l), "image/svg+xml").querySelector("svg");
          i && a(
            C.svgToBase64(
              i,
              {
                size: s,
                classes: t,
                color: o,
                fillColor: m,
                strokeColor: h,
                strokeWidth: d
              },
              [!!v]
            )
          );
        }
      }
    }
  }, [
    s,
    t,
    r,
    m,
    h,
    d,
    g,
    T,
    f
  ]), w)
    return /* @__PURE__ */ A(
      "img",
      {
        className: `ar-LoadableIcon${t ? " " + t : ""}`,
        src: e,
        style: {
          width: W || s || "1rem",
          height: E || s || "1rem"
        },
        alt: "Icon"
      }
    );
  if (g && !B) {
    const o = T ? M || r : f && P || r;
    a(
      C.svgToBase64(
        g,
        {
          size: s,
          classes: t,
          color: o,
          fillColor: m,
          strokeColor: h,
          strokeWidth: d
        },
        [!!v]
      )
    );
  }
  const K = {
    ...z || {},
    width: `calc(${W || s || "1rem"} + ${L ? "0.5rem" : "0px"})`,
    height: `calc(${E || s || "1rem"} + ${L ? "0.5rem" : "0px"})`
  };
  return B ? /* @__PURE__ */ A(
    "img",
    {
      className: `ar-LoadableIcon${t ? " " + t : ""}${L ? " hover-shadow p-1" : ""}`,
      onClick: _ || (() => {
      }),
      src: `data:image/svg+xml;base64,${B}`,
      style: K,
      onMouseEnter: (o) => {
        D(!0), N && N(o);
      },
      onMouseLeave: (o) => {
        D(!1), O && O(o);
      },
      onClickCapture: () => j(!f),
      alt: "Icon"
    }
  ) : null;
};
export {
  ee as default
};
